Subject: Re: linux-next: build failure after merge of the net-next tree

From: Kevin 'ldir' Darbyshire-Bryant <[email-masked]>
Date: Wed, 19 Jun 2019 16:11:57 +0000

> On 19 Jun 2019, at 16:09, Kevin 'ldir' Darbyshire-Bryant <[email-masked]> wrote:
> 
> 
> 
>> On 19 Jun 2019, at 15:13, David Miller <[email-masked]> wrote:
>> 
>> 
>> I've fixed this as follows, thanks:
>> 
>> ====================
>> From 23cdf8752b26d4edbd60a6293bca492d83192d4d Mon Sep 17 00:00:00 2001
>> From: "David S. Miller" <[email-masked]>
>> Date: Wed, 19 Jun 2019 10:12:58 -0400
>> Subject: [PATCH] act_ctinfo: Don't use BIT() in UAPI headers.
>> 
>> Use _BITUL() instead.
>> 
>> Reported-by: Stephen Rothwell <[email-masked]>
>> Signed-off-by: David S. Miller <[email-masked]>
>> ---
>> include/uapi/linux/tc_act/tc_ctinfo.h | 4 ++--
>> 1 file changed, 2 insertions(+), 2 deletions(-)
>> 
>> diff --git a/include/uapi/linux/tc_act/tc_ctinfo.h b/include/uapi/linux/tc_act/tc_ctinfo.h
>> index da803e05a89b..32337304fbe5 100644
>> --- a/include/uapi/linux/tc_act/tc_ctinfo.h
>> +++ b/include/uapi/linux/tc_act/tc_ctinfo.h
>> @@ -27,8 +27,8 @@ enum {
>> #define TCA_CTINFO_MAX (__TCA_CTINFO_MAX - 1)
>> 
>> enum {
>> -	CTINFO_MODE_DSCP	= BIT(0),
>> -	CTINFO_MODE_CPMARK	= BIT(1)
>> +	CTINFO_MODE_DSCP	= _BITUL(0),
>> +	CTINFO_MODE_CPMARK	= _BITUL(1)
>> };
>> 
>> #endif
>> --
>> 2.20.1
>> 
> 
> Hi David,
> 
> Thanks for that.  Owe you a beer!
> 
> Thinking out loud, doesn’t this also require:
> 
> #include <linux/const.h>
> 
> 
> Or at least iproute2 would need to know about _BITUL as it doesn’t at present.
> Which also means iproute2’s Linux uapi shadow would also have to import
> linux/const.h.  Or have I got wrong end of stick?
> 
> Cheers,
> 
> Kevin
> 

Whilst out walking the dog I realised I’m a moron.

The CTINFO_MODE_FOO is only used within module, it shouldn’t even be exposed
to user space.

I’ll send a patch shortly.  Sorry, I’m pretty embarrassed at how something so
apparently simple on the surface has had so many issues.

Cheers,

Kevin D-B

gpg: 012C ACB2 28C6 C53E 9775  9123 B3A2 389B 9DE2 334A